#!/usr/bin/perl

# Affiliate Master  Copyright 1999 by Allen Says

########################################
###### START OF CONFIGURATION AREA #####
########################################

# user database file
$resellerdb = "resellerdb.txt";

#####################################
##### END OF CONFIGURATION AREA #####
#####################################











$MONTH{'01'} = "January";
$MONTH{'02'} = "February";
$MONTH{'03'} = "March";
$MONTH{'04'} = "April";
$MONTH{'05'} = "May";
$MONTH{'06'} = "June";
$MONTH{'07'} = "July";
$MONTH{'08'} = "August";
$MONTH{'09'} = "September";
$MONTH{'10'} = "October";
$MONTH{'11'} = "November";
$MONTH{'12'} = "December";


read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs)
{
   ($name, $value) = split(/=/, $pair);

   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<([^>]|\n)*>//g;
   $value =~ s/<//g;
   $value =~ s/>//g;
   $FORM{$name} = $value;
}

&verify_required_fields;
&find_member_info;
&get_date;
&determine_date_range;
&display_commissions;
exit;


######################################################
### sub  verify_required_fields
###
###   Will verify that all required fields have been entered
######################################################
sub verify_required_fields
{
   $number_required = @required_fields;
   $found_in_list = 0;
   $missing_something = 0;

   for ($counter = 0; $counter < $number_required; $counter++)
   {
      $check = $required_fields[$counter];
      $check =~ s/^\s+//g;
      $check =~ s/\s+$//g;

      if ($FORM{$check} eq '')
      {
         if ($missing_something == 0) { &print_missing_header; $missing_something = 1; }
         print "<font color=blue><li> <b>$check</b></font><br>\n";
      }
   }

   if ($missing_something == 1)
   {
      print "<BR><b>Please hit your browser's \"back\" button and enter required information.</b></center><br>\n";
      exit;
   }

}

sub print_missing_header
{
   print "Content-type: text/html\n\n";
   print "<html><head><title>Ooops, You Forgot To Enter Some Data!</title></head>\n";
   print "<body bgcolor=white><br><center><font size=5 color=blue>\n";
   print "<b>Ooops, You Forgot To Enter Some Data</b></font><br><br>\n";
   print "<b>The following fields are required:</b><p>\n";
}


sub find_member_info
{
   my ($match, $line, @lines);

   open(FILE2, "$resellerdb") or return;
   flock (FILE2, 2);
   @lines = <FILE2>;
   close (FILE2);

   $match = 0;

   foreach $line (@lines)
   {
      $line =~ s/\n//g;
      $line =~ s/\r//g;

      %VERIFY = &breakup_line($line);

      if($VERIFY{'idnumber'} eq $FORM{'idnumber'})
      {
         $match = 1;
         &set_member_info;
         last;
      }
   }
}

sub set_member_info
{
   $FORM{'sponsorfullname'} = $VERIFY{'fullname'};
   $FORM{'sponsoremail'} = $VERIFY{'email'};
}


sub breakup_line
{
   my ($input) = @_;
   my (%DATA);

   ($DATA{'idnumber'},$DATA{'sponsorid'},$DATA{'fullname'},$DATA{'email'}) = split(/&&/, $input);
   return %DATA;
}


######################################################
### sub  get_date
###
###   Gets the current date
######################################################
sub get_date
{
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
   $mon = $mon + 1;
   if ($mon < 10)
   {
      $mon = "0$mon";
   }

   if ($mday < 10)
   {
      $mday = "0$mday";
   }

   $year = $year + 1900;

   $thedate = "$year$mon$mday";
   $FORM{'thedate'} = "$year$mon$mday";
}


sub determine_date_range
{
   if ($FORM{'current_month'})
   {
      $FORM{'heading'} = "Commissions for the current month of <b>$MONTH{substr($thedate, 4, 2)}, " . substr($thedate, 0, 4) . "</b>";
      $from_date = substr($thedate, 0, 4) . substr($thedate, 4, 2);
   }
   elsif ($FORM{'last_month'})
   {
      $the_month = substr($thedate, 4, 2) - 1;
      $the_year = substr($thedate, 0, 4);
      if ($the_month < 10)
      {
         $the_month = "0$the_month";
      }

      if ($the_month == 0)
      {
         $the_month = 12;
         $the_year = $the_year - 1;
      }

      $FORM{'heading'} = "Commissions for the previous month of <b>$MONTH{$the_month}, $the_year</b>";

      $from_date = $the_year . $the_month;
   }
   else
   {
      if ($FORM{'from_month'} ne "")
      {
         $from_date = $FORM{'from_year'} . $FORM{'from_month'};
      }
      else
      {
         $from_date = substr($thedate, 0, 4) . substr($thedate, 4, 2);
      }

      $the_year = substr($from_date, 0, 4);

      $FORM{'heading'} = "Commissions for the month of <b>$MONTH{substr($from_date, 4, 2)}, $the_year</b>";
   }
}


sub display_commissions
{
   $commissions_file = "$from_date.txt";

   open(FILE,$commissions_file)
      or &cgierr("error in display commissions. unable to open internal id file: $commissions_file. Reason: $!");
   @lines = <FILE>;
   close(FILE);

   $total_orderamt = 0;
   $total_commissions = 0;
   $total_orders = 0;

   print "Content-type: text/html\n\n";

   &display_header;

   foreach $line (@lines)
   {
      $line =~ s/\n//g;
      $line =~ s/\r//g;
      ($sponsorid, $saledate, $ordernumber, $orderamt, $commission) = split(/\&\&/, $line);

      if ($FORM{'idnumber'} eq $sponsorid)
      {
         &display_record;
      }
   }

   &display_trailer;
}

sub display_header
{

print qq|

<html><head><meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Sales &amp; Commissions Report</title></head>

<body><p align="center"><font face="Arial" color="#0000FF"><big><strong>Online Sales &amp;
Commissions Report</strong></big></font></p>

<p align="center"><strong><font face="Arial">$FORM{'sponsorfullname'}</font></strong><br>
<strong><font face="Arial">$FORM{'sponsoremail'}</font></strong><br>
<strong><font face="Arial">ID: $FORM{'idnumber'}</font></strong></p>
<p align="center"><strong><font face="Arial">$FORM{'heading'}</font></strong></p>
<div align="center"><center>

<table border="2" cellpadding="0" cellspacing="0" width="550" bgcolor="#DEDEDE">
  <tr>
    <td align="center"><small><font face="Arial" color="#0000FF"><strong>Date of Sale</strong></font></small></td>
    <td align="center" height="16"><small><font face="Arial" color="#0000FF"><strong>Order #
    </strong></font></small></td>
    <td align="center" height="16"><small><font face="Arial" color="#0000FF"><strong>Order
    Amount</strong></font></small></td>
    <td align="center" height="16"><font face="Arial" color="#0000FF"><small><strong>Commissions</strong></small></font></td>
    <td align="center" height="16"><small><font face="Arial" color="#0000FF"><strong>Reseller ID
    </strong></font></small></td>
  </tr>
|;
}

sub display_record
{
   $saledate = &reformat_date($saledate);

   $total_commissions = $total_commissions + $commission;
   $total_orderamt = $total_orderamt + $orderamt;
   $total_orders++;

   $commission = sprintf("%.2f", $commission);
   $orderamt = sprintf("%.2f", $orderamt);

   print qq|<tr><td align="center" width="100"><small><font face="Arial">&nbsp;$saledate&nbsp;</font></small></td>
                <td align="center" width="100"><small><font face="Arial">&nbsp;$ordernumber&nbsp;</font></small></td>
                <td align="right" width="100"><small><font face="Arial">&nbsp;\$$orderamt&nbsp;&nbsp;</font></small></td>
                <td align="right" width="100"><small><font face="Arial">&nbsp;\$$commission&nbsp;&nbsp;</font></small></td>
                <td align="center" width="100"><small><font face="Arial">&nbsp;$sponsorid&nbsp;</font></small></td></tr>|;
}

sub display_trailer
{

   $total_orderamt = sprintf("%.2f", $total_orderamt);
   $total_commissions = sprintf("%.2f", $total_commissions);


print qq|</tr></table></center></div>

<br>&nbsp;
<div align="center"><center>

<table border="2" cellpadding="0" cellspacing="0" width="250" bgcolor="#DEDEDE">
  <tr>
    <td width="150"><font face="Arial" color="#0000FF"><small><strong>Total # Orders</strong></small></font></td>
    <td align="right" width="100">&nbsp;<b>$total_orders</b>&nbsp;&nbsp;</td>
  </tr>
  <tr>
    <td width="100"><font face="Arial" color="#0000FF"><small><strong>Total Order Amount</strong></small></font></td>
    <td align="right" width="100">&nbsp;<b>\$$total_orderamt</b>&nbsp;&nbsp;</td>
  </tr>
  <tr>
    <td><small><font face="Arial" color="#0000FF"><strong>Total Commissions</strong></font></small></td>
    <td align="right">&nbsp;<b>\$$total_commissions</b>&nbsp;&nbsp;</td>
  </tr>
</table>
</center></div>


|;
}

sub reformat_date
{
   my ($input) = @_;
   $formatted_date = substr($input, 4, 2) . "/" . substr($input, 6, 2) . "/" . substr($input, 2, 2);
   return $formatted_date;
}


sub cgierr {
# --------------------------------------------------------
# Displays any errors and prints out FORM and ENVIRONMENT
# information. Useful for debugging.

	if (!$html_headers_printed) {
		print "Content-type: text/plain\n\n";
		$html_headers_printed = 1;
	}
	print "<PRE>\nCGI Error: $!\n";
	print "Message: $_[0]\n\n";
	print "_________Form Variables __________\n";
	foreach $key (sort keys %in) {
		print "$key: \t$in{$key}\n";
	}

	print "\n_________Environment Variables__________\n";
	foreach $env (sort keys %ENV) {
		print "$env: \t$ENV{$env}\n";
	}
	print "\n</PRE>";
	exit;
}

